theory Safety_Checkers
  imports Safety_Checker Safety_Proof_Parsers
begin

text {* Here we instantiate "theory" by LIA. *}

interpretation LIA_checker: art_checker LIA entailment_checker entailment_checker
  unfolding art_checker_def by (auto simp: lin_ineq_theory.theory_checker)

definition safety_checker :: "string \<Rightarrow> string + string" where [code]:
  "safety_checker input \<equiv>
   case LIA_parse_safety_cert_problem input of
     Left e \<Rightarrow> Inl (''error parsing input:\<newline>'' @ e)
   | Right (Safety_Cert_Problem (P,err) cert) \<Rightarrow>
       (case LIA_checker.art_safety_checker P cert err of
          Inl e \<Rightarrow> Inl (''error ensuring safety:\<newline>'' @ e [])
        | Inr () \<Rightarrow> Inr (''ensured safety of node '' @ err))"

end